# (C) 2001-2012 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License Subscription 
# Agreement, Altera MegaCore Function License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


add_parameter PREAMBLE_PASSTHROUGH INTEGER 0
set_parameter_property PREAMBLE_PASSTHROUGH DISPLAY_NAME "Preamble Pass-Through Mode"
set_parameter_property PREAMBLE_PASSTHROUGH DISPLAY_HINT boolean
set_parameter_property PREAMBLE_PASSTHROUGH DESCRIPTION "Instantiate Preamble Passthrough Component"

add_parameter ENABLE_PFC INTEGER 0
set_parameter_property ENABLE_PFC DISPLAY_NAME "Priority-based Flow Control (PFC)"
set_parameter_property ENABLE_PFC DISPLAY_HINT boolean
set_parameter_property ENABLE_PFC DESCRIPTION "Enable Priority-based Flow Control Feature"

add_parameter PFC_PRIORITY_NUM INTEGER 8
set_parameter_property PFC_PRIORITY_NUM DISPLAY_NAME "Number of PFC Priorities"
set_parameter_property PFC_PRIORITY_NUM allowed_ranges {2:8}
set_parameter_property PFC_PRIORITY_NUM DESCRIPTION "Number of PFC Priorities Used"

add_parameter DATAPATH_OPTION INTEGER 3
set_parameter_property DATAPATH_OPTION DISPLAY_NAME "Datapath Option"
set_parameter_property DATAPATH_OPTION allowed_ranges {"1:TX Only" "2:RX Only" "3:TX & RX"}
set_parameter_property DATAPATH_OPTION DESCRIPTION "Datapath Option"

add_parameter ENABLE_SUPP_ADDR INTEGER 1
set_parameter_property ENABLE_SUPP_ADDR DISPLAY_NAME "Supplementary Address"
set_parameter_property ENABLE_SUPP_ADDR DISPLAY_HINT boolean
set_parameter_property ENABLE_SUPP_ADDR DESCRIPTION "Enable Supplementary Address Feature"

add_parameter INSTANTIATE_TX_CRC INTEGER 1
set_parameter_property INSTANTIATE_TX_CRC DISPLAY_NAME "CRC on Transmit Path"
set_parameter_property INSTANTIATE_TX_CRC DISPLAY_HINT boolean
set_parameter_property INSTANTIATE_TX_CRC DESCRIPTION "Instantiate CRC Component on Transmit Path"

add_parameter INSTANTIATE_STATISTICS INTEGER 1
set_parameter_property INSTANTIATE_STATISTICS DISPLAY_NAME "Statistics Collection"
set_parameter_property INSTANTIATE_STATISTICS DISPLAY_HINT boolean
set_parameter_property INSTANTIATE_STATISTICS DESCRIPTION "Instantiate Statistics Component"

add_parameter REGISTER_BASED_STATISTICS INTEGER 0
set_parameter_property REGISTER_BASED_STATISTICS DISPLAY_NAME "Statistics Counters"
set_parameter_property REGISTER_BASED_STATISTICS allowed_ranges {"0:Memory-based" "1:Register-based"}
set_parameter_property REGISTER_BASED_STATISTICS DESCRIPTION "Enable Statistics Implemented Using Register"


add_display_item "MAC Options" PREAMBLE_PASSTHROUGH parameter
add_display_item "MAC Options" ENABLE_PFC parameter
add_display_item "MAC Options" PFC_PRIORITY_NUM parameter
add_display_item "Resource Optimization Options" DATAPATH_OPTION parameter
add_display_item "Resource Optimization Options" ENABLE_SUPP_ADDR parameter
add_display_item "Resource Optimization Options" INSTANTIATE_TX_CRC parameter
add_display_item "Resource Optimization Options" INSTANTIATE_STATISTICS parameter
add_display_item "Resource Optimization Options" REGISTER_BASED_STATISTICS parameter


proc ethernet_10g_mac_update_gui {} {
    set datapath_option [get_parameter_value DATAPATH_OPTION]
    set stat_ena [get_parameter_value INSTANTIATE_STATISTICS]
    set pfc_ena [get_parameter_value ENABLE_PFC]
    
    if {$pfc_ena == 0} {
        set_parameter_property PFC_PRIORITY_NUM ENABLED false
    } else {
        set_parameter_property PFC_PRIORITY_NUM ENABLED true
    }
    
    if {$stat_ena == 0} {
        set_parameter_property REGISTER_BASED_STATISTICS ENABLED false
    } else {
        set_parameter_property REGISTER_BASED_STATISTICS ENABLED true
    }
    
    if {[_get_device_type]} {
        set_parameter_property REGISTER_BASED_STATISTICS allowed_ranges {"0:Memory-based"}
    } else {
        set_parameter_property REGISTER_BASED_STATISTICS allowed_ranges {"0:Memory-based" "1:Register-based"}
    }
    
    # TX Only
    if { $datapath_option == 1 } {
        set_parameter_property ENABLE_SUPP_ADDR ENABLED false
    } else {
        set_parameter_property ENABLE_SUPP_ADDR ENABLED true
    }
    
    # RX Only
    if { $datapath_option == 2 } {
        set_parameter_property INSTANTIATE_TX_CRC ENABLED false
    } else {
        set_parameter_property INSTANTIATE_TX_CRC ENABLED true
    }
}
